lwIP 2.1.2 Lightweight IP stack

Macros
Memory pools
Infrastructure

## Macros
#define | LWIP_MEMPOOL_PROTOTYPE(name) extern const struct memp_desc memp_ ## name
#define | LWIP_MEMPOOL_DECLARE(name, num, size, desc)
#define | LWIP_MEMPOOL_INIT(name) memp_init_pool(&memp_ ## name)
#define | LWIP_MEMPOOL_ALLOC(name) memp_malloc_pool(&memp_ ## name)
#define | LWIP_MEMPOOL_FREE(name, x) memp_free_pool(&memp_ ## name, (x))

## Detailed Description

Custom memory pools

## Macro Definition Documentation

## ◆ LWIP_MEMPOOL_ALLOC

#define LWIP_MEMPOOL_ALLOC | ( |  | name | ) | memp_malloc_pool(&memp_ ## name)

Allocate from a private memory pool

## ◆ LWIP_MEMPOOL_DECLARE

#define LWIP_MEMPOOL_DECLARE | ( |  | name,
|  |  | num,
|  |  | size,
|  |  | desc
| ) |  |

Value:
LWIP_DECLARE_MEMORY_ALIGNED(memp_memory_ ## name ## _base, ((num) * (MEMP_SIZE + MEMP_ALIGN_SIZE(size)))); \
\
LWIP_MEMPOOL_DECLARE_STATS_INSTANCE(memp_stats_ ## name) \
\
static struct memp *memp_tab_ ## name; \
\
const struct memp_desc memp_ ## name = { \
DECLARE_LWIP_MEMPOOL_DESC(desc) \
LWIP_MEMPOOL_DECLARE_STATS_REFERENCE(memp_stats_ ## name) \
LWIP_MEM_ALIGN_SIZE(size), \
(num), \
memp_memory_ ## name ## _base, \
&memp_tab_ ## name \
};
memp_desc::size
u16_t size
Definition: memp_priv.h:119
memp_desc::num
u16_t num
Definition: memp_priv.h:123
LWIP_DECLARE_MEMORY_ALIGNED
#define LWIP_DECLARE_MEMORY_ALIGNED(variable_name, size)
Definition: arch.h:271
memp_desc
Definition: memp_priv.h:108

Declare a private memory pool Private mempools example: .h: only when pool is used in multiple .c files: LWIP_MEMPOOL_PROTOTYPE(my_private_pool); .c:

- in global variables section: LWIP_MEMPOOL_DECLARE(my_private_pool, 10, sizeof(foo), "Some description")
- call ONCE before using pool (e.g. in some init() function): LWIP_MEMPOOL_INIT(my_private_pool);
- allocate: void* my_new_mem = LWIP_MEMPOOL_ALLOC(my_private_pool);
- free: LWIP_MEMPOOL_FREE(my_private_pool, my_new_mem);

To relocate a pool, declare it as extern in cc.h. Example for GCC: extern u8_t __attribute__((section(".onchip_mem"))) memp_memory_my_private_pool_base[];

## ◆ LWIP_MEMPOOL_FREE

#define LWIP_MEMPOOL_FREE | ( |  | name,
|  |  | x
| ) |  | memp_free_pool(&memp_ ## name, (x))

Free element from a private memory pool

## ◆ LWIP_MEMPOOL_INIT

#define LWIP_MEMPOOL_INIT | ( |  | name | ) | memp_init_pool(&memp_ ## name)

Initialize a private memory pool

## ◆ LWIP_MEMPOOL_PROTOTYPE

#define LWIP_MEMPOOL_PROTOTYPE | ( |  | name | ) | extern const struct memp_desc memp_ ## name

Declare prototype for private memory pool if it is used in multiple files